package bioinformatica.programmazione.esami.luglio.primaparte;

/**
 * Classe che manipola stringe.
 * 
 * @author mace
 * @version 1.0
 * 
 */
public class RaggruppaVocaliConsonanti {

	/**
	 * Metodo di test.
	 * 
	 * @param args
	 *            argomenti passati da linea di comando
	 */
	public static void main(String[] args) {
		System.out
				.println(raggruppaVocaliConsonanti("PrecipiTevoLissimevolmentE"));

	}

	/**
	 * Restituisce la stringa che si ottiene dalla stringa passata come
	 * parametro raggruppandone le vocali e le consonanti.
	 * 
	 * @param s
	 *            stringa di riferimento.
	 * @return la stringa che si ottiene da <code>s</code> raggruppando tutte le
	 *         vocali all'inizio e tutte le consonanti alla fine.
	 */
	public static String raggruppaVocaliConsonanti(String s) {
		String gruppoVocali = "";
		String gruppoConsonanti = "";

		for (int i = 0; i < s.length(); i++)
			if (isVocale(s.charAt(i)))
				gruppoVocali += s.charAt(i);
			else
				gruppoConsonanti += s.charAt(i);

		return gruppoVocali + gruppoConsonanti;

	}

	/**
	 * Verifica se un carattere e' una vocale.
	 * 
	 * @param c
	 *            il carattere da verificare.
	 * @return <code>true</code> se <code>c</code> e' una vocale,
	 *         <code>false</code> altrimenti.
	 */
	public static boolean isVocale(char c) {
		char[] vocali = { 'a', 'e', 'i', 'o', 'u', 'A', 'E', 'I', 'O', 'U' };
		for (char vocale : vocali)
			if (c == vocale)
				return true;
		return false;
	}

}