package bioinformatica.programmazione.esami.luglio.secondaparte;

/**
 * Classe che risolve il secondo esercizio dell'esame dell'11 luglio 2014.
 * 
 * @author bioInfo
 * @version 1.0
 * 
 */
public class IndexMaxEl {

	/**
	 * Metodo test.
	 * 
	 * @param args
	 *            argomenti ricevuti da linea di comando, non sono utilizzati
	 *            dal metodo.
	 */
	public static void main(String[] args) {
		int[] vett = { 1, 2, 62, 6, 48, 12, 13, 24, 36, 36 };

		System.out.println(indexMaxEl(vett, 0));
		System.out.println(indexMaxEl(vett, 5));
		System.out.println(indexMaxEl(vett, -3));
		System.out.println(indexMaxEl(vett, 10));
	}

	/**
	 * Dato il vettore <code>vett</code>, cerca l'indice dell'elemento massimo
	 * che si trova da <code>pos</code> (compresa) alla fine dell'array.
	 * 
	 * I valori significativi per <code>pos</code> vanno da 0 all'ultima
	 * posizine del vettore (<code>vett.length - 1</code>). <br>
	 * CASO BASE: se <code>pos == vett.length - 1</code> abbiamo un solo
	 * elemento, che e' anche il massimo: restituiamo la sua posizione,
	 * <code>pos</code>. <br>
	 * PASSO INDUTTIVO: se <code>pos < vett.length - 1</code>, calcoliamo
	 * l'indice del massimo tra gli elementi che vanno da <code>pos </code> alla
	 * fine dell'array, confrontiamo i valori contenuti in tale posizione e
	 * quello contenuto in <code>pos</code>, restutiamo la posizione del
	 * maggiore tra i due.
	 * 
	 * @param vett
	 *            vettore in cui cercare il massimo
	 * @param pos
	 *            posizione da cui cercare l'indice del massimo
	 * @return l'indice dell'elemento massimo tra quelli che si trovano tra
	 *         <code>pos</code> e <code> vett.length - 1</code> se
	 *         <code>pos</code> e' nel range degli inidici di <code>vett</code>,
	 *         <code>-1</code> altrimenti.
	 */
	private static int indexMaxEl(int[] vett, int pos) {
		// verifichiamo che pos possa essere l'indice di un array.
		if (pos < 0 || pos >= vett.length)
			return -1;

		// PRECONDIZIONE: 0 <= pos < vett.length
		if (pos == vett.length - 1)
			return pos;

		return vett[pos] >= vett[indexMaxEl(vett, pos + 1)] ? pos : indexMaxEl(
				vett, pos + 1);
	}

}