package bioinformatica.programmazione.esami.luglio.terzaparte;

import java.security.SecureRandom;

public class Main {

	private final static Partito[] partiti = new Partito[] {
			new Partito("Partito dei belli"),
			new Partito("Partito dei brutti"),
			new Partito("Partito mai tornato"),
			new Partito("Partito dei fiori"), new Partito("Partito di tutti"),
			new Partito("Partito di titti"), new Partito("Partito dei nonni") };

	public static void main(String[] args) {
		Elezione e = creaElezione();
		generaVotiACaso(e);
		System.out.println("\nRISULTATI ELEZIONE:\n" + e);
	}

	private static Elezione creaElezione() {
		Elezione e = new Elezione();

		
		try {
			// i partiti dei belli e dei brutti fanno coalizione da soli
			e.registra(partiti[0]);

			e.registra(partiti[1]);

			// il partito mai tornato e il partito dei fiori sono in coalizione 
			e.registra(new Coalizione("Siamo i più forti", partiti[2],
					partiti[3]));

			// il partito di tutti, il partito di titti e il partito dei nonni sono in coalizione
			e.registra(new Coalizione("Futuro radioso", partiti[4], partiti[5],
					partiti[6]));
		} catch (PartitoGiaRegistratoException exc) {
			System.out.println(exc.getMessage());
		} catch (CoalizioneGiaPresenteException exc) {
			System.out.println(exc.getMessage());
		}

		try {
			// questo genera un'eccezione perché il "Partito di titti" è già
			// registrato poiché la sua coalizione "Futuro radioso" è stata
			// registrata
			e.registra(new Partito("Partito di titti"));
		} catch (PartitoGiaRegistratoException exc) {
			System.out.println(exc.getMessage());
		} catch (CoalizioneGiaPresenteException exc) {
			System.out.println(exc.getMessage());
		}

		return e;
	}

	private static void generaVotiACaso(Elezione e) {
		SecureRandom random = new SecureRandom();
		for (int i = 0; i < 89; i++)
			try {
				e.registraVoto(partiti[Math.abs(random.nextInt()) % 7]);
			} catch (PartitoMaiRegistratoException exc) {
				System.out.println(exc.getMessage());
			}
	}
}