package bioinformatica.programmazione.esami.luglio.terzaparte;

/**
 * Classe che rappresenta un partito politico che si presenta alle elezioni.
 * 
 * @author progBioinfo
 * @version 1.0
 * 
 */
public class Partito {

	/**
	 * Il nome del partito.
	 */
	private final String nome;

	/**
	 * Voti ricevuti dal partito.
	 */
	private int votiRicevuti;

	/**
	 * Crea un partito con un dato <code>nome </code> che inizialmente ha zero
	 * voti ricevuti.
	 * 
	 * @param nome
	 */
	public Partito(String nome) {
		this.nome = nome;
		votiRicevuti = 0;
	}

	/**
	 * Restituisce il nome del partito.
	 * 
	 * @return nome del partito.
	 */
	public String getNome() {
		return nome;
	}

	/**
	 * Restituisce i voti ricevuti finora dal partito.
	 * 
	 * @return voti ricevuti.
	 */
	public int getVoti() {
		return votiRicevuti;
	}

	/**
	 * Incrementa di uno i voti ricevuti dal partito.
	 */
	public void aggiungiVoto() {
		votiRicevuti++;
	}

	@Override
	public boolean equals(Object altro) {
		return (altro instanceof Partito)
				&& ((Partito) altro).nome.equals(nome);
	}

}